<?php
/* Copyright (C) 2005-2007 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (c) 2013 Philippe SAGOT <courrier@mon-dolibarr.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
 *		\file       htdocs/core/antispamimage.php
 *		\brief      Return antispam image
 */
define('NOLOGIN',1);

if (! defined('NOREQUIREUSER'))   define('NOREQUIREUSER',1);
if (! defined('NOREQUIREDB'))     define('NOREQUIREDB',1);
if (! defined('NOREQUIRETRAN'))   define('NOREQUIRETRAN',1);
if (! defined('NOREQUIRESOC'))    define('NOREQUIRESOC',1);
if (! defined('NOTOKENRENEWAL'))  define('NOTOKENRENEWAL',1);

require_once '../main.inc.php';
/*
 * View
 */
header("Content-type: image/png");
session_start();

$val='';
$val2='';

$alphabet=array("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z");
array_push($alphabet, "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z");
array_push($alphabet, "1","2","3","4","5","6","7","8","9","0");

mt_srand((double)microtime()*1000000);

// Police et taille des caractères du code
// ---------------------------------------
$police_ttf="../theme/common/captcha.ttf";

// Initialisation de l'image du captcha
// ------------------------------------
$image_captcha = imagecreatetruecolor(80,32);
if (empty($image_captcha))
{
    dol_print_error('',"Problem with GD creation");
    exit;
}

// Définition des couleurs du captcha en RVB
// -----------------------------------------
$color_bg_captcha=imagecolorallocate($image_captcha,255,255,255);
$color_font_captcha=imagecolorallocate($image_captcha,0,0,0);

// Remplissage avec la couleur de fond
// -----------------------------------
imagefill($image_captcha,0,0,$color_bg_captcha);

// Creation du code et écriture au fur et à mesure dans le captcha
// ---------------------------------------------------------------
for($i=0;$i<5;$i++){
		$temp=$alphabet[mt_rand(0,count($alphabet)-1)];
		$inclinaison=mt_rand(0,45)*mt_rand(-1,1);
		imagettftext($image_captcha,12,$inclinaison,6+($i*14),22,$color_font_captcha,$police_ttf,$temp);
        $string.=$temp;
        //$val2=$val2.$alphabet[mt_rand(0,25)];
        }
        
$_SESSION['captcha']=$val;

//imagettftext($image_captcha,$taille_caracteres,0,6+($i*30),26,$color_texte_captcha,$police_caracteres,$val);


// Création de l'image et envoi au navigateur
// ------------------------------------------
imagepng ($image_captcha);

// Suppression des ressources de l'image
// -------------------------------------
imagedestroy($image_captcha);
$sessionkey='dol_antispam_value';
$_SESSION[$sessionkey]=$string;
?>